unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    nIcon: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  ShellApi;

const
  wm_IconMessage = wm_User;

procedure TForm1.Button1Click(Sender: TObject);
var
  nid: TNotifyIconData;
begin
  Inc (nIcon);
  // fill the NotifyIcon data structure
  nid.cbSize := sizeof (nid);
  nid.wnd := Handle;
  nid.uID := nIcon; // icon ID
  nid.uCallBAckMessage := wm_IconMessage;
  nid.hIcon := Application.Icon.Handle;
  nid.szTip := 'Nice icon';
  nid.uFlags := nif_Message or
    nif_Icon or nif_Tip;
  Shell_NotifyIcon (NIM_ADD, @nid);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: INteger;
begin
  for I := 1 to 10 do
    Button1Click(Sender);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  I: INteger;
begin
  for I := 1 to 10 do
    Button2Click(Sender);
end;

end.
