unit WinCrashForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Stump2, Stump3, MmSystem;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  NewForm: TForm;
  Hwnd: THandle;
  Tot, I: Integer;
begin
  NewForm := TForm.Create (Application);
  NewForm.Show;
  NewForm.Update;
  Tot := 0;
  // create a number of windows...
  try
    for I := 1 to 1000000 do
    begin
      Hwnd := CreateWindow ('button', 'Button',
        ws_child or ws_border or bs_pushbutton,        I mod (ClientWidth - 40),
        I mod (ClientHeight - 20),
        40, 20,
        Handle, 0, HInstance, nil);
      if Hwnd = 0 then
      begin
        Tot := I;
        raise Exception.Create ('Out of handles');
      end;
      if (I mod 20) = 0 then
        NewForm.Caption := 'Created: ' +
        IntToStr (I);
      Application.ProcessMessages;
    end;
    Tot := 1000000;
  finally
    Button1.Caption :=
      Format ('Created: %d', [Tot]);
    NewForm.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  H: THandle;
  I, Tot: Integer;
begin
  Tot := 0;
  try
    for I := 1 to 1000000 do
    begin
      H := CreatePen (ps_solid, 1, RGB (0, 0, 0));
      if H = 0 then
      begin
        Tot := I;
        raise Exception.Create ('Out of handles');
      end;
      if (I mod 20) = 0 then
        Button2.Caption := Format ('Created: %d', [I]);
      Application.ProcessMessages;
    end;
    Tot := 1000000;
  finally
    Button2.Caption := Format ('Created: %d', [Tot]);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  p: ^Integer;
begin
  p := nil;
  p^ := 10;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Form3.Show;
end;

const
  Pts: array [1..16, 1..2] of Integer =
   ((0, 0), (400, 0), (400, 200),
   (200, 200), (200, 120), (300, 180),
   (265, 105), (350, 17), (205, 70),
   (120, -10), (180, 140), (50, 250), (200, 120),
   (200, 200), (0, 200), (0, 0));

procedure TForm1.Button6Click(Sender: TObject);
var
  HRegion1: THandle;
  Col: TColor;
begin
  ShowMessage ('Ready for a real crash?');
  Col := Color;
  Color := clRed;
  PlaySound ('boom.wav', 0, snd_sync);
  HRegion1 := CreatePolygonRgn (Pts,
    sizeof (Pts) div 8,
    alternate);
  SetWindowRgn (
    Handle, HRegion1, True);
  ShowMessage ('Now, what have you done?');
  Color := Col;
  ShowMessage ('You should better buy a new monitor');
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  SetWindowRgn (Handle, 0, True);
end;

end.
