//<![CDATA[
	
var map = null;
var geocoder = null;	

function load() 
{
	if (GBrowserIsCompatible())
	{
		map = new GMap2(document.getElementById("map"));
		map.addControl(new GLargeMapControl());
		map.addControl(new GMapTypeControl());
		map.addControl(new GOverviewMapControl());
		map.setCenter(new GLatLng(49.26780455063753, -102.83203125), 3);

		GDownloadUrl("customer.xml" ,function(data, responseCode)
		{
			var xml = GXml.parse(data);
			var markers = xml.documentElement.getElementsByTagName("ROW");
			for (var i = 0; i < markers.length; i++) 
			{
				var address = markers[i].getAttribute("City")+" "+markers[i].getAttribute("Country");
				if (markers[i].getAttribute("State")!=null)
				{
					address = markers[i].getAttribute("City")+" "+markers[i].getAttribute("State")+" "+markers[i].getAttribute("Country");
				}
				var company = markers[i].getAttribute("Company");
				showAddress(address, company);
			}
		});
	}
}

function showAddress(address, company)
{
	geocoder = new GClientGeocoder();
	geocoder.getLatLng(
	address,
	function(point) 
	{
		var marker = new GMarker(point);
		GEvent.addListener(marker, "click", function() 
		{
			marker.openInfoWindowHtml("<b>" + company + "</b>");
		});
		map.addOverlay(marker);
	});
}
	
//]]>